'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));

var HORIZONTAL = "horizontal"; // 水平滚动
var VERTICAL = "vertical"; // 垂直滚动

var noop = function noop() {};
var packRefs = function packRefs() {
  for (var _len = arguments.length, refs = Array(_len), _key = 0; _key < _len; _key++) {
    refs[_key] = arguments[_key];
  }

  return function (node) {
    return refs.forEach(function (ref) {
      if (typeof ref === "function") {
        ref(node);
      } else if (ref) {
        ref.current = node;
      }
    });
  };
};
var setDirectionStyle = function setDirectionStyle(index, direction, speed, containerRect) {
  var width = containerRect.width,
      height = containerRect.height;

  var style = {
    transitionDuration: speed + "ms"
  };
  if (direction === HORIZONTAL) {
    var x = index ? (index - 1) * width : 0;
    style.transform = "translate3d(" + -x + "px, 0px, 0)";
    style.flexDirection = "row";
  } else if (direction === VERTICAL) {
    var y = (index - 1) * height;
    style.transform = "translate3d(0px, " + -y + "px, 0)";
    style.flexDirection = "column";
  }
  return style;
};

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();





var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};









var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var RowBoat = function (_React$Component) {
  inherits(RowBoat, _React$Component);

  function RowBoat(props) {
    classCallCheck(this, RowBoat);

    var _this = possibleConstructorReturn(this, (RowBoat.__proto__ || Object.getPrototypeOf(RowBoat)).call(this, props));

    _initialiseProps.call(_this);

    var index = props.defaultIndex;

    _this.state = {
      index: index,
      containerRect: {
        width: 0,
        height: 0
      }
    };
    return _this;
  }

  createClass(RowBoat, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var autoplay = this.props.autoplay;

      this.setRect();
      autoplay && this.setAutoPlay(true);
      window.addEventListener("resize", this._resize);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var autoplay = this.props.autoplay;

      if (prevProps.autoplay !== autoplay) {
        autoplay && !this.timer ? this.setAutoPlay(true) : this.setAutoPlay(false);
      }
    }
  }, {
    key: "getStateAndMethod",
    value: function getStateAndMethod() {
      var index = this.state.index;
      var getWrapperProps = this.getWrapperProps,
          getContainerProps = this.getContainerProps,
          getItemProps = this.getItemProps,
          setIndex = this.setIndex;


      return {
        index: index,
        getWrapperProps: getWrapperProps,
        getContainerProps: getContainerProps,
        getItemProps: getItemProps,
        setIndex: setIndex
      };
    }
    // 获取容器元素的属性

    // 获取包装元素的属性

  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;

      var element = children(this.getStateAndMethod());

      if (!element) return null;
      return React.cloneElement(element);
    }
  }]);
  return RowBoat;
}(React__default.Component);

RowBoat.propTypes = {
  children: PropTypes.func,
  defaultIndex: PropTypes.number,
  direction: PropTypes.string,
  setDirectionStyle: PropTypes.func,
  length: PropTypes.number,
  speed: PropTypes.number,
  loop: PropTypes.bool,
  autoplay: PropTypes.bool,
  delay: PropTypes.number
};
RowBoat.defaultProps = {
  children: noop,
  defaultIndex: 1,
  direction: HORIZONTAL,
  speed: 300,
  delay: 3000
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this._resize = function () {
    _this2.setRect();
  };

  this.setRect = function () {
    var _containerNode$getBou = _this2._containerNode.getBoundingClientRect(),
        width = _containerNode$getBou.width,
        height = _containerNode$getBou.height;

    _this2.setState({
      containerRect: {
        width: width,
        height: height
      }
    });
  };

  this.setAutoPlay = function (isSet) {
    var delay = _this2.props.delay;

    if (isSet) {
      _this2.timer = setInterval(function () {
        var index = _this2.state.index;
        var _props = _this2.props,
            loop = _props.loop,
            length = _props.length;

        if (!loop && index === length) {
          clearInterval(_this2.timer);
          _this2.timer = null;
        }
        _this2.setIndex(index + 1);
      }, delay);
    } else {
      clearInterval(_this2.timer);
      _this2.timer = null;
    }
  };

  this.getContainerNode = function (node) {
    _this2._containerNode = node;
  };

  this.getWrapperNode = function (node) {
    _this2._wrapperNode = node;
  };

  this.getContainerProps = function () {
    var _babelHelpers$extends;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _ref$refKey = _ref.refKey,
        refKey = _ref$refKey === undefined ? "ref" : _ref$refKey,
        ref = _ref.ref,
        style = _ref.style,
        rest = objectWithoutProperties(_ref, ["refKey", "ref", "style"]);

    return _extends((_babelHelpers$extends = {}, defineProperty(_babelHelpers$extends, refKey, packRefs(ref, _this2.getContainerNode)), defineProperty(_babelHelpers$extends, "style", _extends({
      overflow: "hidden",
      width: "100%",
      height: "100%",
      position: "relative"
    }, style)), _babelHelpers$extends), rest);
  };

  this.getWrapperProps = function () {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var style = _ref2.style,
        rest = objectWithoutProperties(_ref2, ["style"]);
    var _state = _this2.state,
        index = _state.index,
        containerRect = _state.containerRect;
    var _props2 = _this2.props,
        speed = _props2.speed,
        direction = _props2.direction;

    var setStyle = _this2.props.setDirectionStyle || setDirectionStyle;
    return _extends({
      style: _extends({}, setStyle(index, direction, speed, containerRect), {
        display: "flex",
        width: "100%",
        height: "100%",
        transitionProperty: "transform",
        boxSizing: "content-box"
      }, style)
    }, rest);
  };

  this.getItemProps = function () {
    return {
      style: {
        display: "flex",
        flexShrink: 0,
        width: "100%",
        height: "100%"
      }
    };
  };

  this.setIndex = function (index) {
    var currentIndex = _this2.state.index;
    var _props3 = _this2.props,
        length = _props3.length,
        loop = _props3.loop;

    if ((currentIndex === index || index < 1 || index > length) && !loop) return;
    if (loop && index > length) {
      return _this2.setState({
        index: 1
      });
    }
    if (loop && index < 1) {
      return _this2.setState({
        index: length
      });
    }
    _this2.setState({
      index: index
    });
  };
};

exports.HORIZONTAL = HORIZONTAL;
exports.VERTICAL = VERTICAL;
exports['default'] = RowBoat;
